import {EntityRepository, Repository} from "typeorm";
import {CareerPageCms} from "./entities/career-page-cms.entity";
import {UpdateCareerPageCmsDto} from "./dto/update-career-page-cms.dto";

@EntityRepository(CareerPageCms)
export class CareerPageCmsRepository extends Repository<CareerPageCms> {

    async createEntity(dto: UpdateCareerPageCmsDto): Promise<CareerPageCms | Error> {
        try {
            const entity = this.create({
                backgroundImage: dto.backgroundImage,
                mobileBackgroundImage: dto.mobileBackgroundImage,
                title: dto.title,
                subTitle: dto.subTitle,
                description: dto.description,
                buttonLink: dto.buttonLink,
                buttonText: dto.buttonText
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateCareerPageCmsDto, id: string): Promise<CareerPageCms | Error> {
        try {
            await this.update(id, {
                backgroundImage: dto.backgroundImage,
                mobileBackgroundImage: dto.mobileBackgroundImage,
                title: dto.title,
                subTitle: dto.subTitle,
                description: dto.description,
                buttonLink: dto.buttonLink,
                buttonText: dto.buttonText
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<CareerPageCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}