import {Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards} from "@nestjs/common";
import {AdminAuthGuard} from "src/core/guards/admin-auth.guard";
import {Constants} from "src/utils/constants";
import {SecurityPageCmsService} from "./security-page-cms.service";
import {UpdateSecurityPageCmsDto} from "./dto/update-security-page-cms.dto";

@Controller({path: "security-page-cms", version: Constants.API_VERSION_1})

export class SecurityPageCmsController {
    constructor(private readonly service: SecurityPageCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
        @Body() dto: UpdateSecurityPageCmsDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
