import {Module} from '@nestjs/common';
import {TypeOrmModule} from '@nestjs/typeorm';
import {HomePageBrandSectionRepository} from './home-page-brand-section.repository';
import {HomePageBrandSectionController} from './home-page-brand-section.controller';
import {HomePageBrandSectionService} from './home-page-brand-section.service';
import {JwtModule} from '@nestjs/jwt';
import JwtConfigService from 'src/core/jwt/jwt-config.service';
import {UsersRepository} from 'src/modules/users/user.repository';
import JwtHelper from 'src/core/jwt/jwt.helper';
import {DoSpacesService} from "../../SpacesModule/SpacesService/doSpacesService";
import {DoSpacesServicerovider} from "../../SpacesModule/SpacesService";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([HomePageBrandSectionRepository])
    ],
    controllers: [HomePageBrandSectionController],
    providers: [HomePageBrandSectionService, JwtHelper, DoSpacesServicerovider, DoSpacesService
    ]
})
export class HomePageBrandSectionModule {
}
