import {Module} from '@nestjs/common';
import {TypeOrmModule} from '@nestjs/typeorm';
import {JwtModule} from '@nestjs/jwt';
import JwtConfigService from 'src/core/jwt/jwt-config.service';
import {UsersRepository} from 'src/modules/users/user.repository';
import JwtHelper from 'src/core/jwt/jwt.helper';
import {PartyRepository} from '../party/party.repository';
import {InvitesController} from './invites.controller';
import {InvitesService} from './invites.service';
import {InvitesRepository} from './invites.repository';
import {TransactionRepository} from '../transaction/transaction.repository';

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([InvitesRepository, UsersRepository, TransactionRepository, PartyRepository]),
    ],
    controllers: [InvitesController],
    providers: [InvitesService, JwtHelper]
})
export class InvitesModule {
}
