import { HttpException, HttpStatus, Injectable } from "@nestjs/common";
import { InjectRepository } from "@nestjs/typeorm";
import { FindOperator, Like } from "typeorm";
import { ResponseUtils } from "src/utils/response.utils";
import { FaqContentRepository } from "../CRUD/faq-content/faq-content.repository";
import { FAQPageCmsRepository } from "../CMS/faq-page-cms/faq-page-cms.repository";
import { AboutUsPageCmsRepository } from "../CMS/about-us-page-cms/about-us-page-cms.repository";
import { AboutPageContentRepository } from "../CRUD/about-page-content/about-page-content.repository";
import { LeadersContentRepository } from "../CRUD/leaders-content/leaders-content.repository";
import { PressAboutContentCmsRepository } from "../CMS/press-about-content-cms/press-about-content-cms.repository";
import { PressKitPageCmsRepository } from "../CMS/press-kit-page-cms/press-kit-page-cms.repository";
import { PressLinkContentRepository } from "../CRUD/press-link-content/press-link-content.repository";
import { PressCoverageContentRepository } from "../CRUD/press-coverage-content/press-coverage-content.repository";
import { CareerPageCmsRepository } from "../CMS/career-page-cms/career-page-cms.repository";
import { CareerTeamRepository } from "../CRUD/career-team/career-team.repository";
import { CareerLocationRepository } from "../CRUD/career-location/career-location.repository";
import { ContactUsPageCmsRepository } from "../CMS/contact-us-page-cms/contact-us-page-cms.repository";
import { DesignationRepository } from "../CRUD/designation/designation.repository";
import { OrganizationSizeRepository } from "../CRUD/organization-size/organization-size.repository";
import { AccelerateContentRepository } from "../CRUD/accelerate-content/accelerate-content.repository";
import { PartnerPageCmsRepository } from "../CMS/partner-page-cms/partner-page-cms.repository";
import { PremiumPartnersContentRepository } from "../CRUD/premium-partners-content/premium-partners-content.repository";
import { HeaderFooterCmsRepository } from "../CMS/header-footer-cms/header-footer-cms.repository";
import { OfficeContentRepository } from "../CRUD/office-content/office-content.repository";
import { SocialLinkRepository } from "../CRUD/social-link/social-link.repository";
import { CareerModelRepository } from "../CRUD/career-model/career-model.repository";
import { CareerDetailsPageCmsRepository } from "../CMS/career-details-page-cms/career-details-page-cms.repository";
import { SchedulePageCmsRepository } from "../CMS/schedule-page-cms/schedule-page-cms.repository";
import { ScheduleRoleRepository } from "../CRUD/schedule-role/schedule-role.repository";
import {
    ScheduleTransactionLimitRepository
} from "../CRUD/schedule-transaction-limit/schedule-transaction-limit.repository";
import { ScheduleIndustryRepository } from "../CRUD/schedule-industry/schedule-industry.repository";
import {
    HomePageHeroSectionCmsRepository
} from "../CMS/home-page-hero-section-cms/home-page-hero-section-cms.repository";
import { HomePageBrandSectionRepository } from "../CRUD/home-page-brand-section/home-page-brand-section.repository";
import {
    BenefitsAndAdvantageSectionCmsRepository
} from "../CMS/benefits-and-advantage-section-cms/benefits-and-advantage-section-cms.repository";
import {
    BenefitsAndAdvantageSectionRepository
} from "../CRUD/benefits-and-advantage-section/benefits-and-advantage-section.repository";
import {
    MarketYourBusinessSectionCmsRepository
} from "../CMS/market-your-business-section-cms/market-your-business-section-cms.repository";
import { ImproveSectionCmsRepository } from "../CMS/improve-section-cms/improve-section-cms.repository";
import { HowItWorksSectionCmsRepository } from "../CMS/how-it-works-section-cms/how-it-works-section-cms.repository";
import { HowItWorksSectionRepository } from "../CRUD/how-it-works-section/how-it-works-section.repository";
import { NewsletterCmsRepository } from "../CMS/newsletter-cms/newsletter-cms.repository";
import { CustomerReviewsCmsRepository } from "../CMS/customer-reviews-cms/customer-reviews-cms.repository";
import { CustomerReviewsRepository } from "../CRUD/customer-reviews/customer-reviews.repository";
import { EasyPaymentSectionCmsRepository } from "../CMS/easy-payment-section-cms/easy-payment-section-cms.repository";
import { PaymentPackageRepository } from "../CRUD/payment-package/payment-package.repository";
import { ApplicationsIntegrationRepository } from "../CRUD/applications-integration/applications-integration.repository";
import { WhatsNextSectionCmsRepository } from "../CMS/whats-next-section-cms/whats-next-section-cms.repository";
import { SitePageTitleCmsRepository } from "../CMS/site-page-title-cms/site-page-title-cms.repository";
import {
    ApplicationsIntegrationCmsRepository
} from "../CMS/applications-integration-cms/applications-integration-cms.repository";
import { SigninCmsRepository } from "../CMS/signin-cms/signin-cms.repository";
import { SignupCmsRepository } from "../CMS/signup-cms/signup-cms.repository";
import { AuthCommonDataRepository } from "../CRUD/auth-common-data/auth-common-data.repository";
import { ContactModelRepository } from "../CRUD/contact-model/contact-model.repository";
import { SubscriptionModelRepository } from "../CRUD/subscription-model/subscription-model.repository";
import { CareerApplicationModelRepository } from "../CRUD/career-application-model/career-application-model.repository";
import { ScheduleModelRepository } from "../CRUD/schedule-model/schedule-model.repository";
import { TransactionRepository } from "../transaction/transaction.repository";
import { PartyRepository } from "../party/party.repository";
import { TransactionNotesRepository } from "../transaction-notes/transaction-notes.repository";
import { Constants } from "src/utils/constants";
import { UsersRepository } from "../users/user.repository";
import { TransactionAddressDetailsRepository } from "../transaction-address-details/transaction-address-details.repository";
import { TransactionTimelineDetailsRepository } from "../transaction-timeline-details/transaction-timeline-details.repository";
import { TransactionDocumentsRepository } from "../transaction-documents/transaction-documents.repository";
import { EventScheduleRepository } from "../event-schedule/event-schedule.repository";
import { InvitesRepository } from "../invites/invites.repository";

@Injectable()
export class SiteFrontendService {
    constructor(
        @InjectRepository(FaqContentRepository)
        private readonly faqContentRepository: FaqContentRepository,
        @InjectRepository(FAQPageCmsRepository)
        private readonly faqPageCmsRepository: FAQPageCmsRepository,
        @InjectRepository(AboutUsPageCmsRepository)
        private readonly aboutUsPageCmsRepo: AboutUsPageCmsRepository,
        @InjectRepository(AboutPageContentRepository)
        private readonly aboutPageContentRepo: AboutPageContentRepository,
        @InjectRepository(LeadersContentRepository)
        private readonly leadersContentRepo: LeadersContentRepository,
        @InjectRepository(PressAboutContentCmsRepository)
        private readonly pressAboutContentCmsRepo: PressAboutContentCmsRepository,
        @InjectRepository(PressKitPageCmsRepository)
        private readonly pressKitPageCmsRepo: PressKitPageCmsRepository,
        @InjectRepository(PressLinkContentRepository)
        private readonly pressLinkContentRepo: PressLinkContentRepository,
        @InjectRepository(PressCoverageContentRepository)
        private readonly pressCoverageContentRepo: PressCoverageContentRepository,
        @InjectRepository(CareerPageCmsRepository)
        private readonly careerPageCmsRepository: CareerPageCmsRepository,
        @InjectRepository(CareerTeamRepository)
        private readonly careerTeamRepository: CareerTeamRepository,
        @InjectRepository(CareerLocationRepository)
        private readonly careerLocationRepository: CareerLocationRepository,
        @InjectRepository(ContactUsPageCmsRepository)
        private readonly contactUsPageCmsRepo: ContactUsPageCmsRepository,
        @InjectRepository(DesignationRepository)
        private readonly designationRepo: DesignationRepository,
        @InjectRepository(OrganizationSizeRepository)
        private readonly organizationSizeRepo: OrganizationSizeRepository,
        @InjectRepository(AccelerateContentRepository)
        private readonly accelerateContentRepo: AccelerateContentRepository,
        @InjectRepository(PartnerPageCmsRepository)
        private readonly partnerPageCmsRepo: PartnerPageCmsRepository,
        @InjectRepository(PremiumPartnersContentRepository)
        private readonly premiumPartnerContentRepo: PremiumPartnersContentRepository,
        @InjectRepository(HeaderFooterCmsRepository)
        private readonly headerFooterCmsRepo: HeaderFooterCmsRepository,
        @InjectRepository(OfficeContentRepository)
        private readonly officeContentRepository: OfficeContentRepository,
        @InjectRepository(SocialLinkRepository)
        private readonly socialLinkRepository: SocialLinkRepository,
        @InjectRepository(CareerModelRepository)
        private readonly careerModelRepository: CareerModelRepository,
        @InjectRepository(CareerDetailsPageCmsRepository)
        private readonly careerDetailsPageCmsRepository: CareerDetailsPageCmsRepository,
        @InjectRepository(SchedulePageCmsRepository)
        private readonly schedulePageCmsRepo: SchedulePageCmsRepository,
        @InjectRepository(ScheduleRoleRepository)
        private readonly scheduleRoleRepo: ScheduleRoleRepository,
        @InjectRepository(ScheduleTransactionLimitRepository)
        private readonly scheduleTransactionLimitRepo: ScheduleTransactionLimitRepository,
        @InjectRepository(ScheduleIndustryRepository)
        private readonly scheduleIndustryRepo: ScheduleIndustryRepository,
        @InjectRepository(HomePageHeroSectionCmsRepository)
        private readonly homePageHeroSectionCmsRepository: HomePageHeroSectionCmsRepository,
        @InjectRepository(HomePageBrandSectionRepository)
        private readonly homePageBrandSectionRepository: HomePageBrandSectionRepository,
        @InjectRepository(BenefitsAndAdvantageSectionCmsRepository)
        private readonly benefitsAndAdvantageSectionCmsRepository: BenefitsAndAdvantageSectionCmsRepository,
        @InjectRepository(BenefitsAndAdvantageSectionRepository)
        private readonly benefitsAndAdvantageSectionRepository: BenefitsAndAdvantageSectionRepository,
        @InjectRepository(MarketYourBusinessSectionCmsRepository)
        private readonly marketYourBusinessSectionCmsRepository: MarketYourBusinessSectionCmsRepository,
        @InjectRepository(ImproveSectionCmsRepository)
        private readonly improveSectionCmsRepository: ImproveSectionCmsRepository,
        @InjectRepository(HowItWorksSectionCmsRepository)
        private readonly howItWorksSectionCmsRepository: HowItWorksSectionCmsRepository,
        @InjectRepository(HowItWorksSectionRepository)
        private readonly howItWorksSectionRepository: HowItWorksSectionRepository,
        @InjectRepository(NewsletterCmsRepository)
        private readonly newsletterCmsRepository: NewsletterCmsRepository,
        @InjectRepository(CustomerReviewsCmsRepository)
        private readonly customerReviewsCmsRepository: CustomerReviewsCmsRepository,
        @InjectRepository(CustomerReviewsRepository)
        private readonly customerReviewsRepository: CustomerReviewsRepository,
        @InjectRepository(EasyPaymentSectionCmsRepository)
        private readonly easyPaymentSectionCmsRepository: EasyPaymentSectionCmsRepository,
        @InjectRepository(PaymentPackageRepository)
        private readonly paymentPackageRepository: PaymentPackageRepository,
        @InjectRepository(ApplicationsIntegrationRepository)
        private readonly applicationsIntegrationRepository: ApplicationsIntegrationRepository,
        @InjectRepository(WhatsNextSectionCmsRepository)
        private readonly whatsNextSectionCmsRepository: WhatsNextSectionCmsRepository,
        @InjectRepository(SitePageTitleCmsRepository)
        private readonly sitePageTitleCmsRepository: SitePageTitleCmsRepository,
        @InjectRepository(ApplicationsIntegrationCmsRepository)
        private readonly applicationsIntegrationCmsRepository: ApplicationsIntegrationCmsRepository,
        @InjectRepository(SigninCmsRepository)
        private readonly signinCmsRepository: SigninCmsRepository,
        @InjectRepository(SignupCmsRepository)
        private readonly signupCmsRepository: SignupCmsRepository,
        @InjectRepository(AuthCommonDataRepository)
        private readonly authCommonDataRepository: AuthCommonDataRepository,
        @InjectRepository(ContactModelRepository)
        private readonly contactModelRepository: ContactModelRepository,
        @InjectRepository(SubscriptionModelRepository)
        private readonly subscriptionModelRepository: SubscriptionModelRepository,
        @InjectRepository(CareerApplicationModelRepository)
        private readonly careerApplicationModelRepository: CareerApplicationModelRepository,
        @InjectRepository(ScheduleModelRepository)
        private readonly scheduleModelRepository: ScheduleModelRepository,
        @InjectRepository(TransactionRepository)
        private readonly transactionRepository: TransactionRepository,
        @InjectRepository(TransactionNotesRepository)
        private readonly transactionNotesRepository: TransactionNotesRepository,
        @InjectRepository(PartyRepository)
        private readonly partyRepository: PartyRepository,
        @InjectRepository(UsersRepository)
        private readonly usersRepository: UsersRepository,
        @InjectRepository(TransactionAddressDetailsRepository)
        private readonly transactionAddressDetailsRepository: TransactionAddressDetailsRepository,
        @InjectRepository(TransactionTimelineDetailsRepository)
        private readonly transactionTimelineDetailsRepository: TransactionTimelineDetailsRepository,
        @InjectRepository(TransactionDocumentsRepository)
        private readonly transactionDocumentsRepository: TransactionDocumentsRepository,
        @InjectRepository(EventScheduleRepository)
        private readonly eventScheduleRepository: EventScheduleRepository,
        @InjectRepository(InvitesRepository)
        private readonly invitesRepository: InvitesRepository,
    ) {
    }

    async getFaqPageData(): Promise<any | Error> {
        const faqPageCmsData = await this.faqPageCmsRepository.findAll();
        const faqContentData = await this.faqContentRepository.findByFilterQuery({});

        const response = {
            faqPageCmsData: faqPageCmsData,
            faqContentData: faqContentData,
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }


    async getAboutPageData(): Promise<any | Error> {
        const aboutUsPageCmsData = await this.aboutUsPageCmsRepo.findAll();
        const aboutPageContentData = await this.aboutPageContentRepo.findByFilterQuery({});
        const leadersContentData = await this.leadersContentRepo.findByFilterQuery({});

        const response = {
            aboutUsPageCmsData: aboutUsPageCmsData,
            aboutPageContentData: aboutPageContentData,
            leadersContentData: leadersContentData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getPressData(): Promise<any | Error> {
        const pressAboutContentCmsData = await this.pressAboutContentCmsRepo.findByFilterQuery({});
        const pressKitPageCmsData = await this.pressKitPageCmsRepo.findAll();
        const pressLinkContentData = await this.pressLinkContentRepo.findByFilterQuery({});
        const pressCoverageContentData = await this.pressCoverageContentRepo.findByFilterQuery({});

        const response = {
            pressAboutContentCmsData: pressAboutContentCmsData,
            pressKitPageCmsData: pressKitPageCmsData,
            pressLinkContentData: pressLinkContentData,
            pressCoverageContentData: pressCoverageContentData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getCareerPageData(): Promise<any | Error> {
        const careerPageCmsData = await this.careerPageCmsRepository.findAll();
        const careerTeamData = await this.careerTeamRepository.findByFilterQuery({});
        const careerLocationData = await this.careerLocationRepository.findByFilterQuery({});

        const response = {
            careerPageCmsData: careerPageCmsData,
            careerTeamData: careerTeamData,
            careerLocationData: careerLocationData
        }

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getContactPageData(): Promise<any | Error> {
        const contactUsPageCmsData = await this.contactUsPageCmsRepo.findAll();
        const designationData = await this.designationRepo.findByFilterQuery({});
        const organizationSizeData = await this.organizationSizeRepo.findByFilterQuery({});

        const response = {
            contactUsPageCmsData,
            designationData,
            organizationSizeData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getPartnerPageData(): Promise<any | Error> {
        const accelerateContentData = await this.accelerateContentRepo.findByFilterQuery({});
        const partnerPageCmsData = await this.partnerPageCmsRepo.findAll();
        const premiumPartnerContentData = await this.premiumPartnerContentRepo.findByFilterQuery({});

        const response = {
            accelerateContentData,
            partnerPageCmsData,
            premiumPartnerContentData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }


    async getCommonCMSData(): Promise<any | Error> {
        const headerFooterCmsData = await this.headerFooterCmsRepo.findAll();
        const officeContentData = await this.officeContentRepository.findByFilterQuery({});
        const socialLinkData = await this.socialLinkRepository.findByFilterQuery({});
        const pageTitleCmsData = await this.sitePageTitleCmsRepository.findAll();
        const signInCms = await this.signinCmsRepository.findAll();
        const signUpCms = await this.signupCmsRepository.findAll();
        const authCommonCms = await this.authCommonDataRepository.findByFilterQuery({});

        const response = {
            headerFooterCmsData,
            officeContentData,
            socialLinkData,
            pageTitleCmsData,
            signInCms,
            signUpCms,
            authCommonCms
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getCareerListData(
        keyword: any,
        teamName: any,
        location: any
    ): Promise<any | Error> {
        type FindOption = {
            team?: FindOperator<string>;
            locationType?: FindOperator<string>;
            title?: FindOperator<string>;
        };

        const findOptions: FindOption = {};

        if (keyword) findOptions.title = Like("%" + keyword + "%");
        if (teamName) findOptions.team = teamName;
        if (location) findOptions.locationType = location;

        const careerList = await this.careerModelRepository.findCareerByFilterQuery(
            findOptions
        );

        let data = {
            careerList: careerList
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", data);
    }

    async getCareerDetailsData(id: string): Promise<any | Error> {
        const cmsData = await this.careerDetailsPageCmsRepository.findAll();
        const careerDetailsData = await this.careerModelRepository.findByFilterQuery({ id: id });

        const response = {
            cmsData: cmsData,
            careerDetailsData: careerDetailsData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", response);
    }

    async getScheduleData(): Promise<any | Error> {
        const schedulePageCmsData = await this.schedulePageCmsRepo.findAll();
        const scheduleRoleData = await this.scheduleRoleRepo.findByFilterQuery({});
        const scheduleTransactionLimitData = await this.scheduleTransactionLimitRepo.findByFilterQuery({});
        const scheduleIndustryData = await this.scheduleIndustryRepo.findByFilterQuery({});

        const response = {
            schedulePageCmsData,
            scheduleRoleData,
            scheduleTransactionLimitData,
            scheduleIndustryData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getHomePageData(): Promise<any | Error> {
        const heroSectionCmsData = await this.homePageHeroSectionCmsRepository.findAll();
        const brandData = await this.homePageBrandSectionRepository.findByFilterQuery({});
        const benefitsAndAdvantageSectionData = await this.benefitsAndAdvantageSectionRepository.findByFilterQuery({});
        const benefitsAndAdvantageSectionCmsData = await this.benefitsAndAdvantageSectionCmsRepository.findAll();
        const marketBusinessSectionCmsData = await this.marketYourBusinessSectionCmsRepository.findAll();
        const improveSectionCmsData = await this.improveSectionCmsRepository.findAll();
        const howItWorksSectionCmsData = await this.howItWorksSectionCmsRepository.findAll();
        const howItWorksSectionData = await this.howItWorksSectionRepository.findByFilterQuery({});
        const newsletterCmsData = await this.newsletterCmsRepository.findAll();
        const customerReviewsCmsData = await this.customerReviewsCmsRepository.findAll();
        const customerReviewsData = await this.customerReviewsRepository.findByFilterQuery({});
        const easyPaymentSectionCmsData = await this.easyPaymentSectionCmsRepository.findAll();
        const paymentPackageData = await this.paymentPackageRepository.findByFilterQuery({});
        const whatsNextSectionCmsData = await this.whatsNextSectionCmsRepository.findAll();
        const applicationsIntegrationData = await this.applicationsIntegrationRepository.findByFilterQuery({});
        const applicationsIntegrationCmsData = await this.applicationsIntegrationCmsRepository.findAll();

        const response = {
            heroSectionCmsData,
            brandData,
            benefitsAndAdvantageSectionCmsData,
            benefitsAndAdvantageSectionData,
            marketBusinessSectionCmsData,
            improveSectionCmsData,
            howItWorksSectionCmsData,
            howItWorksSectionData,
            newsletterCmsData,
            customerReviewsCmsData,
            customerReviewsData,
            easyPaymentSectionCmsData,
            paymentPackageData,
            applicationsIntegrationData,
            whatsNextSectionCmsData,
            applicationsIntegrationCmsData
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
    }

    async getDashboardData(): Promise<any | Error> {
        const totalContact = await this.contactModelRepository.countAllQuery();
        const totalSubscriber = await this.subscriptionModelRepository.countAllQuery();
        const totalCareerApplicant = await this.careerApplicationModelRepository.countAllQuery();
        const totalCareer = await this.careerModelRepository.countAllQuery();
        const totalSchedule = await this.scheduleModelRepository.countAllQuery();

        const response = {
            totalContact: totalContact,
            totalSubscriber: totalSubscriber,
            totalCareerApplicant: totalCareerApplicant,
            totalCareer: totalCareer,
            totalSchedule: totalSchedule
        };

        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", response);
    }

    async getSiteTransaction(user: any): Promise<any | Error> {
        const transactionIds = await this.partyRepository.find({
            where: { userId: user.id, isDeleted: false },
            select: ["transactionId"]
        });

        const ids = transactionIds?.map(x => x.transactionId)

        const data = await this.transactionRepository.siteTransactionQuery(ids);
        if (!data) {
            throw new HttpException(
                Constants.NOT_FOUND,
                HttpStatus.NOT_FOUND
            );
        }

        return ResponseUtils.successResponseHandler(200, "Data Fetched Successfully", "data", data);
    }

    async findTransactionDetailsById(id: string): Promise<any | Error> {
        const transaction: any = await this.transactionRepository.findOneEntity(id);
        if (transaction) {
            const transactionNotes = await this.transactionNotesRepository.findByFilterQuery({ transactionId: id });
            const customerInformation: any = await this.usersRepository.findOneEntity(transaction.userId);
            const partyList: any = await this.partyRepository.findByFilterQuery({ transactionId: id });
            const users = [];
            if (Object.keys(partyList).length > 0) {
                for (let party of partyList) {
                    const user: any = await this.usersRepository.findOneEntity(party.userId);
                    if (user) {
                        const { password, role, userType, createdAt, updatedAt, isDeleted, ...rest } = user;
                        users.push(rest);
                    }
                }
            }
            const transactionAddressDetails = await this.transactionAddressDetailsRepository.findByFilterQuery({ transactionId: id });
            const transactionTimelineDetails = await this.transactionTimelineDetailsRepository.findByFilterQuery({ transactionId: id });
            const transactionDocuments = await this.transactionDocumentsRepository.findByFilterQuery({ transactionId: id });
            const formattedResponse = {
                transaction,
                transactionNotes,
                customerInformation,
                parties: users,
                transactionAddressDetails,
                transactionTimelineDetails,
                transactionDocuments,
            };
            return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", formattedResponse);
        } else {
            throw new HttpException(
                Constants.NOT_FOUND,
                HttpStatus.NOT_FOUND
            );
        }
    }

    async findUserSchedule(id: string, page: number, limit: number): Promise<any | Error> {
        const schedules = await this.eventScheduleRepository.findScheduleOfUser(id, page, limit);
        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", schedules);
    }

    async getUserProfile(id: string): Promise<any | Error> {
        const data = await this.usersRepository.findOneEntity(id);
        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", data);
    }

    async getUserInvites(id: string): Promise<any | Error> {
        const data = await this.invitesRepository.getInvitesWithTrxNUser(id);
        return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", data);
    }

    async changeTransactionOwner(user: any, transactionId: string, dto: any) {
        const { email } = dto;
        if(!email) {
            throw new HttpException(
                `User email is required to change ownership!`,
                HttpStatus.BAD_REQUEST
            );
        }
        const transaction = await this.transactionRepository.findOne(transactionId);
        if(!transaction) {
            throw new HttpException(
                `Transaction not found!`,
                HttpStatus.BAD_REQUEST
            );
        }
        if(transaction.userId !== user.id) {
            throw new HttpException(
                `You are not the owner of this transaction!`,
                HttpStatus.BAD_REQUEST
            );
        }
        const newOwner: any = await this.usersRepository.findByEmailAddress(email);
        if (!newOwner) {
            throw new HttpException(
                `User not found with the provided email address!`,
                HttpStatus.NOT_FOUND
            );
        }
        const {id: newOwnerId} = newOwner; 
        if(user.id === newOwnerId) {
            throw new HttpException(
                `You already are the owner of this transaction!`,
                HttpStatus.BAD_REQUEST
            );
        }

        const updateddto = {
            userId: newOwnerId,
            userName: newOwner.firstName + newOwner.lastName
        }

        const updatedTransaction = await this.transactionRepository.updateEntity(transactionId, updateddto);

        return ResponseUtils.successResponseHandler(200, "Data Updated Successfully", "data", updatedTransaction);
    }
}
