import {Module} from '@nestjs/common';
import {JwtModule} from '@nestjs/jwt';
import {TypeOrmModule} from '@nestjs/typeorm';
import JwtConfigService from 'src/core/jwt/jwt-config.service';
import JwtHelper from 'src/core/jwt/jwt.helper';
import { TransactionAddressDetailsRepository } from './transaction-address-details.repository';
import TransactionAddressDetailsController from './transaction-address-details.controller';
import { TransactionAddressDetailsService } from './transaction-address-details.service';
import { TransactionRepository } from '../transaction/transaction.repository';
import { UsersRepository } from '../users/user.repository';

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([TransactionAddressDetailsRepository, TransactionRepository, UsersRepository]),
    ],
    controllers: [TransactionAddressDetailsController],
    providers: [TransactionAddressDetailsService, JwtHelper]
})
export class TransactionAddressDetailsModule {
}
