import {Module} from '@nestjs/common';
import {JwtModule} from '@nestjs/jwt';
import {TypeOrmModule} from '@nestjs/typeorm';
import JwtConfigService from 'src/core/jwt/jwt-config.service';
import JwtHelper from 'src/core/jwt/jwt.helper';
import { TransactionRepository } from '../transaction/transaction.repository';
import { UsersRepository } from '../users/user.repository';
import { TransactionDocumentsRepository } from './transaction-documents.repository';
import TransactionDocumentsController from './transaction-documents.controller';
import { TransactionDocumentsService } from './transaction-documents.service';
import { DoSpacesService } from '../SpacesModule/SpacesService/doSpacesService';
import { DoSpacesServicerovider } from '../SpacesModule/SpacesService';
import { FileUploadsService } from '../file-uploads/file-uploads.service';

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([TransactionDocumentsRepository, TransactionRepository, UsersRepository]),
    ],
    controllers: [TransactionDocumentsController],
    providers: [TransactionDocumentsService, JwtHelper, FileUploadsService, DoSpacesServicerovider, DoSpacesService]
})
export class TransactionDocumentsModule {
}
