import {Module} from '@nestjs/common';
import {JwtModule} from '@nestjs/jwt';
import {TypeOrmModule} from '@nestjs/typeorm';
import JwtConfigService from 'src/core/jwt/jwt-config.service';
import JwtHelper from 'src/core/jwt/jwt.helper';
import { TransactionRepository } from '../transaction/transaction.repository';
import { UsersRepository } from '../users/user.repository';
import { TransactionTimelineDetailsRepository } from './transaction-timeline-details.repository';
import TransactionTimelineDetailsController from './transaction-timeline-details.controller';
import { TransactionTimelineDetailsService } from './transaction-timeline-details.service';

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([TransactionTimelineDetailsRepository, TransactionRepository, UsersRepository]),
    ],
    controllers: [TransactionTimelineDetailsController],
    providers: [TransactionTimelineDetailsService, JwtHelper]
})
export class TransactionTimelineDetailsModule {
}
